<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
    <!-- Generated by javadoc -->
    <title>TextPieceTable (POI API Documentation)</title>
    <link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
    <script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="TextPieceTable (POI API Documentation)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":42,"i5":42,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10,"i11":10,"i12":10,"i13":10,"i14":10,"i15":10,"i16":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"],32:["t6","Deprecated Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";

</script>
<noscript>
    <div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.top.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/TextPieceTable.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/hwpf/model/TextPiece.html"
               title="class in org.apache.poi.hwpf.model"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../../org/apache/poi/hwpf/model/TextPieceTable.FCComparator.html"
               title="class in org.apache.poi.hwpf.model"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/hwpf/model/TextPieceTable.html" target="_top">Frames</a>
        </li>
        <li><a href="TextPieceTable.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_top">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
            <li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.top">
        <!--   -->
    </a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
    <div class="subTitle">org.apache.poi.hwpf.model</div>
    <h2 title="Class TextPieceTable" class="title">Class TextPieceTable</h2>
</div>
<div class="contentContainer">
    <ul class="inheritance">
        <li>java.lang.Object</li>
        <li>
            <ul class="inheritance">
                <li>org.apache.poi.hwpf.model.TextPieceTable</li>
            </ul>
        </li>
    </ul>
    <div class="description">
        <ul class="blockList">
            <li class="blockList">
                <dl>
                    <dt>All Implemented Interfaces:</dt>
                    <dd><a href="../../../../../org/apache/poi/hwpf/model/CharIndexTranslator.html"
                           title="interface in org.apache.poi.hwpf.model">CharIndexTranslator</a></dd>
                </dl>
                <dl>
                    <dt>Direct Known Subclasses:</dt>
                    <dd><a href="../../../../../org/apache/poi/hwpf/model/OldTextPieceTable.html"
                           title="class in org.apache.poi.hwpf.model">OldTextPieceTable</a></dd>
                </dl>
                <hr>
                <br>
                <pre><a href="../../../../../org/apache/poi/util/Internal.html"
                        title="annotation in org.apache.poi.util">@Internal</a>
public class <span class="typeNameLabel">TextPieceTable</span>
extends java.lang.Object
implements <a href="../../../../../org/apache/poi/hwpf/model/CharIndexTranslator.html"
              title="interface in org.apache.poi.hwpf.model">CharIndexTranslator</a></pre>
                <div class="block">The piece table for matching up character positions to bits of text. This
                    mostly works in bytes, but the TextPieces themselves work in characters. This
                    does the icky convertion.
                </div>
                <dl>
                    <dt><span class="simpleTagLabel">Author:</span></dt>
                    <dd>Ryan Ackley</dd>
                </dl>
            </li>
        </ul>
    </div>
    <div class="summary">
        <ul class="blockList">
            <li class="blockList">
                <!-- ======== NESTED CLASS SUMMARY ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="nested.class.summary">
                        <!--   -->
                    </a>
                        <h3>Nested Class Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Nested Class Summary table, listing nested classes, and an explanation">
                            <caption><span>Nested Classes</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Class and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colFirst"><code>protected static class&nbsp;</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPieceTable.FCComparator.html"
                                        title="class in org.apache.poi.hwpf.model">TextPieceTable.FCComparator</a></span></code>&nbsp;
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- =========== FIELD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="field.summary">
                        <!--   -->
                    </a>
                        <h3>Field Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Field Summary table, listing fields, and an explanation">
                            <caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Field and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colFirst"><code>protected java.util.ArrayList&lt;<a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPiece.html"
                                        title="class in org.apache.poi.hwpf.model">TextPiece</a>&gt;</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPieceTable.html#Z:Z_textPieces">_textPieces</a></span></code>&nbsp;
                                </td>
                            </tr>
                            <tr class="rowColor">
                                <td class="colFirst"><code>protected java.util.ArrayList&lt;<a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPiece.html"
                                        title="class in org.apache.poi.hwpf.model">TextPiece</a>&gt;</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPieceTable.html#Z:Z_textPiecesFCOrder">_textPiecesFCOrder</a></span></code>&nbsp;
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- ======== CONSTRUCTOR SUMMARY ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.summary">
                        <!--   -->
                    </a>
                        <h3>Constructor Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Constructor Summary table, listing constructors, and an explanation">
                            <caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colOne" scope="col">Constructor and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPieceTable.html#TextPieceTable--">TextPieceTable</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr class="rowColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPieceTable.html#TextPieceTable-byte:A-byte:A-int-int-int-">TextPieceTable</a></span>(byte[]&nbsp;documentStream,
                                    byte[]&nbsp;tableStream,
                                    int&nbsp;offset,
                                    int&nbsp;size,
                                    int&nbsp;fcMin)</code>&nbsp;
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- ========== METHOD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.summary">
                        <!--   -->
                    </a>
                        <h3>Method Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Method Summary table, listing methods, and an explanation">
                            <caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span
                                    id="t2" class="tableTab"><span><a
                                    href="javascript:show(2);">Instance Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a
                                    href="javascript:show(8);">Concrete Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t6" class="tableTab"><span><a
                                    href="javascript:show(32);">Deprecated Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Method and Description</th>
                            </tr>
                            <tr id="i0" class="altColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPieceTable.html#add-org.apache.poi.hwpf.model.TextPiece-">add</a></span>(<a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPiece.html"
                                        title="class in org.apache.poi.hwpf.model">TextPiece</a>&nbsp;piece)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i1" class="rowColor">
                                <td class="colFirst"><code>int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPieceTable.html#adjustForInsert-int-int-">adjustForInsert</a></span>(int&nbsp;listIndex,
                                    int&nbsp;length)</code>
                                    <div class="block">Adjust all the text piece after inserting some text into one of
                                        them
                                    </div>
                                </td>
                            </tr>
                            <tr id="i2" class="altColor">
                                <td class="colFirst"><code>boolean</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPieceTable.html#equals-java.lang.Object-">equals</a></span>(java.lang.Object&nbsp;o)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i3" class="rowColor">
                                <td class="colFirst"><code>int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPieceTable.html#getByteIndex-int-">getByteIndex</a></span>(int&nbsp;charPos)</code>
                                    <div class="block">Calculates the byte index of the given char index.</div>
                                </td>
                            </tr>
                            <tr id="i4" class="altColor">
                                <td class="colFirst"><code>int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPieceTable.html#getCharIndex-int-">getCharIndex</a></span>(int&nbsp;bytePos)</code>
                                    <div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
                                </td>
                            </tr>
                            <tr id="i5" class="rowColor">
                                <td class="colFirst"><code>int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPieceTable.html#getCharIndex-int-int-">getCharIndex</a></span>(int&nbsp;startBytePos,
                                    int&nbsp;startCP)</code>
                                    <div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
                                </td>
                            </tr>
                            <tr id="i6" class="altColor">
                                <td class="colFirst"><code>int[][]</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPieceTable.html#getCharIndexRanges-int-int-">getCharIndexRanges</a></span>(int&nbsp;startBytePosInclusive,
                                    int&nbsp;endBytePosExclusive)</code>
                                    <div class="block">Finds character ranges that includes specified byte range.</div>
                                </td>
                            </tr>
                            <tr id="i7" class="rowColor">
                                <td class="colFirst"><code>int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPieceTable.html#getCpMin--">getCpMin</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i8" class="altColor">
                                <td class="colFirst"><code>protected int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPieceTable.html#getEncodingMultiplier-org.apache.poi.hwpf.model.TextPiece-">getEncodingMultiplier</a></span>(<a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPiece.html"
                                        title="class in org.apache.poi.hwpf.model">TextPiece</a>&nbsp;textPiece)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i9" class="rowColor">
                                <td class="colFirst"><code>java.lang.StringBuilder</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPieceTable.html#getText--">getText</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i10" class="altColor">
                                <td class="colFirst"><code>java.util.List&lt;<a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPiece.html"
                                        title="class in org.apache.poi.hwpf.model">TextPiece</a>&gt;</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPieceTable.html#getTextPieces--">getTextPieces</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i11" class="rowColor">
                                <td class="colFirst"><code>int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPieceTable.html#hashCode--">hashCode</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i12" class="altColor">
                                <td class="colFirst"><code>boolean</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPieceTable.html#isIndexInTable-int-">isIndexInTable</a></span>(int&nbsp;bytePos)</code>
                                    <div class="block">Check if index is in table</div>
                                </td>
                            </tr>
                            <tr id="i13" class="rowColor">
                                <td class="colFirst"><code>int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPieceTable.html#lookIndexBackward-int-">lookIndexBackward</a></span>(int&nbsp;startBytePos)</code>
                                    <div class="block">Return last index <= bytePos that is in table</div>
                                </td>
                            </tr>
                            <tr id="i14" class="altColor">
                                <td class="colFirst"><code>int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPieceTable.html#lookIndexForward-int-">lookIndexForward</a></span>(int&nbsp;startBytePos)</code>
                                    <div class="block">Return first index >= bytePos that is in table</div>
                                </td>
                            </tr>
                            <tr id="i15" class="rowColor">
                                <td class="colFirst"><code>protected <a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPiece.html"
                                        title="class in org.apache.poi.hwpf.model">TextPiece</a></code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPieceTable.html#newTextPiece-int-int-byte:A-org.apache.poi.hwpf.model.PieceDescriptor-">newTextPiece</a></span>(int&nbsp;nodeStartChars,
                                    int&nbsp;nodeEndChars,
                                    byte[]&nbsp;buf,
                                    <a href="../../../../../org/apache/poi/hwpf/model/PieceDescriptor.html"
                                       title="class in org.apache.poi.hwpf.model">PieceDescriptor</a>&nbsp;pd)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i16" class="altColor">
                                <td class="colFirst"><code>byte[]</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPieceTable.html#writeTo-java.io.ByteArrayOutputStream-">writeTo</a></span>(java.io.ByteArrayOutputStream&nbsp;docStream)</code>&nbsp;
                                </td>
                            </tr>
                        </table>
                        <ul class="blockList">
                            <li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
                                <!--   -->
                            </a>
                                <h3>Methods inherited from class&nbsp;java.lang.Object</h3>
                                <code>clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait</code>
                            </li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
    <div class="details">
        <ul class="blockList">
            <li class="blockList">
                <!-- ============ FIELD DETAIL =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="field.detail">
                        <!--   -->
                    </a>
                        <h3>Field Detail</h3>
                        <a name="Z:Z_textPieces">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>_textPieces</h4>
                                <pre>protected&nbsp;java.util.ArrayList&lt;<a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPiece.html"
                                        title="class in org.apache.poi.hwpf.model">TextPiece</a>&gt; _textPieces</pre>
                            </li>
                        </ul>
                        <a name="Z:Z_textPiecesFCOrder">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>_textPiecesFCOrder</h4>
                                <pre>protected&nbsp;java.util.ArrayList&lt;<a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPiece.html"
                                        title="class in org.apache.poi.hwpf.model">TextPiece</a>&gt; _textPiecesFCOrder</pre>
                            </li>
                        </ul>
                    </li>
                </ul>
                <!-- ========= CONSTRUCTOR DETAIL ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.detail">
                        <!--   -->
                    </a>
                        <h3>Constructor Detail</h3>
                        <a name="TextPieceTable--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>TextPieceTable</h4>
                                <pre>public&nbsp;TextPieceTable()</pre>
                            </li>
                        </ul>
                        <a name="TextPieceTable-byte:A-byte:A-int-int-int-">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>TextPieceTable</h4>
                                <pre>public&nbsp;TextPieceTable(byte[]&nbsp;documentStream,
                      byte[]&nbsp;tableStream,
                      int&nbsp;offset,
                      int&nbsp;size,
                      int&nbsp;fcMin)</pre>
                            </li>
                        </ul>
                    </li>
                </ul>
                <!-- ============ METHOD DETAIL ========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.detail">
                        <!--   -->
                    </a>
                        <h3>Method Detail</h3>
                        <a name="newTextPiece-int-int-byte:A-org.apache.poi.hwpf.model.PieceDescriptor-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>newTextPiece</h4>
                                <pre>protected&nbsp;<a href="../../../../../org/apache/poi/hwpf/model/TextPiece.html"
                                                       title="class in org.apache.poi.hwpf.model">TextPiece</a>&nbsp;newTextPiece(int&nbsp;nodeStartChars,
                                 int&nbsp;nodeEndChars,
                                 byte[]&nbsp;buf,
                                 <a href="../../../../../org/apache/poi/hwpf/model/PieceDescriptor.html"
                                    title="class in org.apache.poi.hwpf.model">PieceDescriptor</a>&nbsp;pd)</pre>
                            </li>
                        </ul>
                        <a name="add-org.apache.poi.hwpf.model.TextPiece-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>add</h4>
                                <pre>public&nbsp;void&nbsp;add(<a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPiece.html"
                                        title="class in org.apache.poi.hwpf.model">TextPiece</a>&nbsp;piece)</pre>
                            </li>
                        </ul>
                        <a name="adjustForInsert-int-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>adjustForInsert</h4>
                                <pre>public&nbsp;int&nbsp;adjustForInsert(int&nbsp;listIndex,
                           int&nbsp;length)</pre>
                                <div class="block">Adjust all the text piece after inserting some text into one of
                                    them
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>listIndex</code> - The TextPiece that had characters inserted into</dd>
                                    <dd><code>length</code> - The number of characters inserted</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="equals-java.lang.Object-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>equals</h4>
                                <pre>public&nbsp;boolean&nbsp;equals(java.lang.Object&nbsp;o)</pre>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Overrides:</span></dt>
                                    <dd><code>equals</code>&nbsp;in class&nbsp;<code>java.lang.Object</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getByteIndex-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getByteIndex</h4>
                                <pre>public&nbsp;int&nbsp;getByteIndex(int&nbsp;charPos)</pre>
                                <div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a
                                        href="../../../../../org/apache/poi/hwpf/model/CharIndexTranslator.html#getByteIndex-int-">CharIndexTranslator</a></code></span>
                                </div>
                                <div class="block">Calculates the byte index of the given char index.</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/hwpf/model/CharIndexTranslator.html#getByteIndex-int-">getByteIndex</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/hwpf/model/CharIndexTranslator.html"
                                                title="interface in org.apache.poi.hwpf.model">CharIndexTranslator</a></code>
                                    </dd>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>charPos</code> - The char position</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>The byte index</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getCharIndex-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getCharIndex</h4>
                                <pre>@Deprecated
public&nbsp;int&nbsp;getCharIndex(int&nbsp;bytePos)</pre>
                                <div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
                            </li>
                        </ul>
                        <a name="getCharIndex-int-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getCharIndex</h4>
                                <pre>@Deprecated
public&nbsp;int&nbsp;getCharIndex(int&nbsp;startBytePos,
                                    int&nbsp;startCP)</pre>
                                <div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
                            </li>
                        </ul>
                        <a name="getCharIndexRanges-int-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getCharIndexRanges</h4>
                                <pre>public&nbsp;int[][]&nbsp;getCharIndexRanges(int&nbsp;startBytePosInclusive,
                                  int&nbsp;endBytePosExclusive)</pre>
                                <div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a
                                        href="../../../../../org/apache/poi/hwpf/model/CharIndexTranslator.html#getCharIndexRanges-int-int-">CharIndexTranslator</a></code></span>
                                </div>
                                <div class="block">Finds character ranges that includes specified byte range.</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/hwpf/model/CharIndexTranslator.html#getCharIndexRanges-int-int-">getCharIndexRanges</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/hwpf/model/CharIndexTranslator.html"
                                                title="interface in org.apache.poi.hwpf.model">CharIndexTranslator</a></code>
                                    </dd>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>startBytePosInclusive</code> - start byte range</dd>
                                    <dd><code>endBytePosExclusive</code> - end byte range</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getEncodingMultiplier-org.apache.poi.hwpf.model.TextPiece-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getEncodingMultiplier</h4>
                                <pre>protected&nbsp;int&nbsp;getEncodingMultiplier(<a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPiece.html"
                                        title="class in org.apache.poi.hwpf.model">TextPiece</a>&nbsp;textPiece)</pre>
                            </li>
                        </ul>
                        <a name="getCpMin--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getCpMin</h4>
                                <pre>public&nbsp;int&nbsp;getCpMin()</pre>
                            </li>
                        </ul>
                        <a name="getText--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getText</h4>
                                <pre>public&nbsp;java.lang.StringBuilder&nbsp;getText()</pre>
                            </li>
                        </ul>
                        <a name="getTextPieces--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getTextPieces</h4>
                                <pre>public&nbsp;java.util.List&lt;<a
                                        href="../../../../../org/apache/poi/hwpf/model/TextPiece.html"
                                        title="class in org.apache.poi.hwpf.model">TextPiece</a>&gt;&nbsp;getTextPieces()</pre>
                            </li>
                        </ul>
                        <a name="hashCode--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>hashCode</h4>
                                <pre>public&nbsp;int&nbsp;hashCode()</pre>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Overrides:</span></dt>
                                    <dd><code>hashCode</code>&nbsp;in class&nbsp;<code>java.lang.Object</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="isIndexInTable-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>isIndexInTable</h4>
                                <pre>public&nbsp;boolean&nbsp;isIndexInTable(int&nbsp;bytePos)</pre>
                                <div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a
                                        href="../../../../../org/apache/poi/hwpf/model/CharIndexTranslator.html#isIndexInTable-int-">CharIndexTranslator</a></code></span>
                                </div>
                                <div class="block">Check if index is in table</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/hwpf/model/CharIndexTranslator.html#isIndexInTable-int-">isIndexInTable</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/hwpf/model/CharIndexTranslator.html"
                                                title="interface in org.apache.poi.hwpf.model">CharIndexTranslator</a></code>
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>true if index in table, false if not</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="lookIndexBackward-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>lookIndexBackward</h4>
                                <pre>public&nbsp;int&nbsp;lookIndexBackward(int&nbsp;startBytePos)</pre>
                                <div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a
                                        href="../../../../../org/apache/poi/hwpf/model/CharIndexTranslator.html#lookIndexBackward-int-">CharIndexTranslator</a></code></span>
                                </div>
                                <div class="block">Return last index <= bytePos that is in table</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/hwpf/model/CharIndexTranslator.html#lookIndexBackward-int-">lookIndexBackward</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/hwpf/model/CharIndexTranslator.html"
                                                title="interface in org.apache.poi.hwpf.model">CharIndexTranslator</a></code>
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>last index less of equal to bytePos that is in table</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="lookIndexForward-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>lookIndexForward</h4>
                                <pre>public&nbsp;int&nbsp;lookIndexForward(int&nbsp;startBytePos)</pre>
                                <div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a
                                        href="../../../../../org/apache/poi/hwpf/model/CharIndexTranslator.html#lookIndexForward-int-">CharIndexTranslator</a></code></span>
                                </div>
                                <div class="block">Return first index >= bytePos that is in table</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code><a
                                            href="../../../../../org/apache/poi/hwpf/model/CharIndexTranslator.html#lookIndexForward-int-">lookIndexForward</a></code>&nbsp;in
                                        interface&nbsp;<code><a
                                                href="../../../../../org/apache/poi/hwpf/model/CharIndexTranslator.html"
                                                title="interface in org.apache.poi.hwpf.model">CharIndexTranslator</a></code>
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>first index greater or equal to bytePos that is in table</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="writeTo-java.io.ByteArrayOutputStream-">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>writeTo</h4>
                                <pre>public&nbsp;byte[]&nbsp;writeTo(java.io.ByteArrayOutputStream&nbsp;docStream)
               throws java.io.IOException</pre>
                                <dl>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code></dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.bottom.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/TextPieceTable.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/hwpf/model/TextPiece.html"
               title="class in org.apache.poi.hwpf.model"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../../org/apache/poi/hwpf/model/TextPieceTable.FCComparator.html"
               title="class in org.apache.poi.hwpf.model"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/hwpf/model/TextPieceTable.html" target="_top">Frames</a>
        </li>
        <li><a href="TextPieceTable.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_bottom">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
            <li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.bottom">
        <!--   -->
    </a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy">
    <small>
        <i>Copyright 2018 The Apache Software Foundation or
            its licensors, as applicable.</i>
    </small>
</p>
</body>
</html>
